#ifndef MathBoxPLUGIN_H
#define MathBoxPLUGIN_H

#include "B5Plugin.h"
#include "PluginRevisions.h"

#include <QString>
#include <QObject>


#define MBOX_PLUGINNAME	"MathBox"
#define MBOX_FILTERNAME	"MathBoxFilter"

#define MBOX_PLUGINGROUP "MathBox" 


class MathBoxPlugin : public QObject, public B5Plugin
{
Q_OBJECT
public:
	MathBoxPlugin() { ; }
	virtual int priority() { return 28; }
	virtual QString name() { return QString(MBOX_PLUGINNAME); }
	virtual QString group() { return QString(MBOX_PLUGINGROUP); }
	virtual bool init(PluginHub *hub, int id, int groupId, const QString &bundlePath);
	virtual bool registerFilters();
	virtual bool registerOptions();
	virtual bool finish();
	virtual PluginDependency *createDependency(const QString &name);
        virtual QList<QString> toolFiles();
        virtual QList<QWidget*> toolWidgets();
        virtual void toolWidgetCreated(QWidget *uiWidget);
    
public slots:
    void handleSettingsChange(const PluginImageSettings &options, const PluginImageSettings &changed, int currentLayer);
    void handleControlChange(const QString &optionName, int groupId, int layer, const PluginImageSettings &options, const PluginOptionList &current, PluginOptionList &changes);
    void handleHotnessChanged(const PluginImageSettings &options);
    void reset();

private:
	PluginHub *m_hub;
	int m_id;
	int m_groupId;
};


#endif
