#ifndef MathBox_PLUGIN_H
#define MathBox_PLUGIN_H

#include "PluginLayerFilter.h"
#include "PluginHub.h"

#define FILTERNAME MathBoxFilter

class FILTERNAME : public PluginLayerFilter
{
public:
	FILTERNAME(PluginHub *hub, int groupId) : m_hub(hub), m_groupId(groupId) { ; }

	virtual QString name() const { return QString("MathBoxFilter"); }


         enum OptionNames { 
                 ENABLED =    1,   //"mbox_enabled"	// Boolean - is the plug-in enabled?
                 RFIELD =     2,   // red formula
                 GFIELD =     3,
                 BFIELD =     4,
                 XFIELD =     5,   // x variable
                 YFIELD =     6,
                 ZFIELD =     7    
         };


	virtual bool needsToRunLayer(const PluginImageSettings &options, const PluginPipeSettings &settings, PluginOptionList &layerOptions) const;
	virtual void runLayer(const PluginImageSettings &options, const PluginPipeSettings &settings, PluginTile &tile, PluginOptionList &layerOptions, int layerPos) const;
	virtual bool isSlow(const PluginImageSettings &options, const PluginPipeSettings &settings) const;
	virtual bool isLargeRadius(const PluginImageSettings &options, const PluginPipeSettings &settings) const;
	virtual bool isPixelSource(const PluginImageSettings &options, const PluginPipeSettings &settings) const;
	virtual QTransform transform(const PluginImageSettings &options, const PluginPipeSettings &settings, const QSize &startSize) const;
	virtual QSize size(const PluginImageSettings &options, const PluginPipeSettings &settings, const QSize &startSize) const;
	virtual QList<PluginDependency*> prerequisites(const PluginImageSettings &options, const PluginPipeSettings &settings, PluginTile &tile) const;
	virtual bool needsOriginalImage() { return false; };


private:
	PluginHub *m_hub;
	int m_groupId;
};


#endif
